(function (define) {
  'use strict';

  define([], function () {

    var ConnectCtrl = function($scope, baseData, userProfile, notificationPopover, $timeout) {
      $scope.loaded = false;
      $scope.pin = '';
      $scope.htmlPin = '';
      $scope.error = '';

      notificationPopover.listenAndPopup($scope);

      baseData.get('/api/profile/pin?profileId={profileId}', {profileId: userProfile.getProfileId(), ttl: 0}).then(function(data){
        //console.log("Display Pin ", data);
        $scope.loaded = true;
        pin2html(data.pin);
      });

      function pin2html(pin) {
        for (var i in pin) {
          if (pin[i] == 1) $scope.htmlPin += '<div class="col icon-button"><i class="fa fa-heart"></i></div>';
          else if (pin[i] == 2) $scope.htmlPin += '<div class="col icon-button"><i class="fa fa-eye"></i></div>';
          else if (pin[i] == 3) $scope.htmlPin += '<div class="col icon-button"><i class="fa fa-cloud"></i></div>';
          else if (pin[i] == 4) $scope.htmlPin += '<div class="col icon-button"><i class="fa fa-moon-o"></i></div>';
          else if (pin[i] == 5) $scope.htmlPin += '<div class="col icon-button"><i class="fa fa-paw"></i></div>';
          else if (pin[i] == 6) $scope.htmlPin += '<div class="col icon-button"><i class="fa fa-tint"></i></div>';
          else if (pin[i] == 7) $scope.htmlPin += '<div class="col icon-button"><i class="fa fa-star"></i></div>';
          else if (pin[i] == 8) $scope.htmlPin += '<div class="col icon-button"><i class="fa fa-pagelines"></i></div>';
          else if (pin[i] == 9) $scope.htmlPin += '<div class="col icon-button"><i class="fa fa-key"></i></div>';
        }
      }

      $scope.connectWith = function(e) {
        if ($scope.pin && $scope.pin.length == 6) {
          $scope.loadButton(e);
          baseData.post('/api/profile/connect?profileId=' + userProfile.getProfileId(), {pin: $scope.pin})
            .then(function () {
                $scope.pin = '';
                $scope.unloadButton(e);
                $timeout(function(){
                  $scope.htmlPin = '';
                },300);
            })
            .catch(function () {
                $scope.unloadButton(e);
            });
        } else {
          $scope.pin = '';
          $scope.htmlPin = '';
          //$scope.error = 'CONNECT_LENGTH_ERROR';
        }
      };
      $scope.addNumber = function(num) {
        $scope.error = '';
        if ($scope.pin.length < 6 && num != 10){
          $scope.pin = $scope.pin + '' + num;
        } else if ($scope.pin.length > 0 && num == 10){
          $scope.pin = $scope.pin.slice(0,-1);
        }
        $scope.htmlPin = '';
        pin2html($scope.pin);
      };
    };

    return ConnectCtrl;
  });

}(define));