(function (define) {
  'use strict';

  define([], function () {

    var ProfilesCtrl = function ($scope, $stateParams, baseData, userProfile, settingsData, notificationPopover, matchesData) {
      var match = matchesData.getMatchById($stateParams.profileId);

      $scope.Math = window.Math;
      $scope.loaded = false;
      baseData.get('/api/match/profile?profileId={profileId}&matchProfileId=' + $stateParams.profileId, userProfile.getProfileId()).then(function(data) {
        $scope.user = data;
        $scope.loaded = true;
      });

      $scope.like = function() {
        $scope.user.liked = true;
        matchesData.like(match);
        matchesData.remove(match);
        matchesData.undoObj.user = match;
        $scope.goto('/app/matches');
      };
      $scope.dislike = function() {
        $scope.user.disliked = true;
        matchesData.dislike(match);
        matchesData.remove(match);
        matchesData.undoObj.user = match;
        $scope.goto('/app/matches');
      };

      $scope.measureDistances = 'km';
      $scope.measureDistancesCalculation = 1;
      settingsData.get().then(function(data){
        $scope.measureDistances = data.preferredDistanceUnit;
        if (data.preferredDistanceUnit != 'km') {
          $scope.measureDistances = 'MEASURE_MILES';
          $scope.measureDistancesCalculation = 0.621371192;
        } else {
          $scope.measureDistances = 'MEASURE_KM';
        }
      });

      notificationPopover.listenAndPopup($scope);
    };

    return ProfilesCtrl;
  });

}(define));