/**

{
  "chatId": "54302a23d944b0a03415957c",
  "participants": [{
    "profileId": "62806595-1340-4c9e-ba5c-c2d8a1eb6a56",
    "firstName": "IOS",
    "imageId": "b0144570-4be5-11e4-8701-f7437c5af76d"
  },{
    "profileId": "a54aef35-796a-4b9c-9ea9-f7928207094a",
    "firstName": "Lemonchella",
    "imageId": "73efa010-4be7-11e4-83ac-e3bf77a58a4a"
  }],
  "messages": [{
    "messageId": "c720417f-8487-4ea3-b57b-59b6d2a430e8",
    "from": "62806595-1340-4c9e-ba5c-c2d8a1eb6a56",
    "text": "Hello Lemonchella ... ",
    "timestamp": 1412442659073,
    "destructionTimestamp": "",
    "state": "read",
    "location": {lat:75.5656, long: 34.45645},
    "digitalAssets": [{
      "id": "dsfg"
      "type": "Image| Video | Voice"
    }]
  }, ...]
}

**/

(function (define) {
  'use strict';

  define(['config'], function (config) {

    var chatMessagesData = function (listData) {
      var apiUrl = '/api/chat/messages?chatId={chatId}&profileId={profileId}';

      return function(chatId) {
        var chatUrl = apiUrl.replace('{chatId}', chatId);

        return {
          get: function(messageId){
            if (messageId) {
              chatUrl = chatUrl + '&lastMessageId=' + messageId;
              listData(chatUrl, 'Chat-' + chatId, {ttl: 0}).get();
            }
            return listData(chatUrl, 'Chat-' + chatId, {ttl: config.ttl.MESSAGES}).get();
          },
          clear: function(){
            listData(chatUrl).clear();
          }
        }
      }
    };

    return chatMessagesData;
  });
}(define));