(function (define, angular) {
  'use strict';

  define(['config','utils'], function (config, utils) {

    var _ = utils._;

    var chatsArchivedCollection = function (collectionData, baseData, $q) {
      var apiUrl = '/api/chat/archived-chats?profileId={profileId}',
        baseInstance = collectionData({
          name: 'chatsArchived',
          url: apiUrl,
          idProp: 'chatId',
          sortBy: 'lastMessageTimeStamp'
        });

      window.Kismet.collections.chatsArchivedCollection = instance;

      var instance = angular.extend(baseInstance, {
        blockUser: blockUser
      });

      function blockUser(chatId, myProfileId) {
        var deferred = $q.defer(),
          chat = baseInstance.get(chatId),
          participantId = chat && chat.participant && chat.participant.profileId;

        baseData.post('/api/profile/blacklist?profileId={profileId}', {blacklistProfileId: participantId}, myProfileId)
          .then(function(){
            instance.remove(chat, true);
            deferred.resolve('OK');
          }).catch(function(err){
            deferred.reject('Sorry, server error. ' + err);
          });

        return deferred.promise;
      }

      return instance;
    };

    return chatsArchivedCollection;
  });
}(define, angular));