(function () {

  var dataMocks = function(require) {

    var config = require('config'),
      url = config.apiUrls;

    var mocks = [{
        url: url.LOGIN,
        data: require('./mocks/login.mock')
      },{
        url: url.LOAD_PROFILE,
        data: require('./mocks/profile.mock')
      }]
      .map(function(m){
        m.url = getBase(m.url);
        return m;
      });

    function getBase(url){
      return url.substring(0, (url.indexOf('?') || url.length));
    }

    return function(url){
      return mocks.reduce(function(acc,cur) {
        return url.indexOf(cur.url) !== -1 ? cur : acc;
      }, {});
    }
  };

  if (typeof exports === 'object') {
    module.exports = dataMocks(require);
  } else if (typeof define === 'function' && define.amd) {
    define(dataMocks);
  }
}());