(function (define) {
  'use strict';

  define(['config'], function (config) {

    var settingsData = function ($rootScope, $q, baseData, userProfile) {
      var apiUrl = '/api/profile/user-settings?profileId={profileId}',
        settings = null;

      function loadSettings() {
        console.log('loadSettings ...');
        return baseData
          .get(apiUrl, {profileId: userProfile.getProfileId(), ttl: 0})
          .then(function(data){
            settings = data;
            return data;
          });
      }
      function fireSignificantChange(oldSettings, newSettings) {
        if (oldSettings && oldSettings.incognitoMode !== newSettings.incognitoMode) {
          $rootScope.$broadcast(config.event.SIGNIFICANT_CHANGE);
        }
      }

      return {
        get: function(){
          return $q.when(settings || loadSettings());
        },
        save: function(newSettings){
          return baseData
            .post(apiUrl, newSettings, userProfile.getProfileId())
            .then(function(data){
              baseData.clearCache(apiUrl);
              fireSignificantChange(settings, data);
              settings = newSettings;
              return data;
            });
        },
        destroy: function() {
          return baseData.post('/api/profile/delete?profileId={profileId}', {}, userProfile.getProfileId());
        },
        reset: function() {
          settings = null;
        }
      }
    };

    return settingsData;
  });
}(define));