/**
 * Dialog fullscreen (e.g. for full image view)
 */

(function (define) {
  'use strict';

  define(['config'], function (config) {

    var fullScreenDialog = function($q, $ionicModal) {

      var popup = function(options) {
        var deferred = $q.defer();

        //img/blank.png
        if (!options.modalScope.src) {
          options.modalScope.src = 'img/blank.png';
        }

        // Use $ionicModal.fromTemplateUrl if gets too complex:
        var modal = $ionicModal
          .fromTemplate(
            '<ion-modal-view ng-click="hide()" class="popup-fullscreen">' +
              '<div class="">' +
                '<img src="img/blank.png" class="full-image scale" km-img data-image-id="imageId" data-image-src="src" data-size="\'normal\'" data-type="\'binary\'" data-ratio="\'keep\'"  />' +
              '</div>' +
            '</ion-modal-view>',
            {
              scope: options.modalScope,
              animation: 'fade-in'
            }
          );

        deferred.resolve(modal);

        return deferred.promise;
      };

      return {
        popup: popup
      };
    };

    return fullScreenDialog;
  })
}(define));