/**
 * Dialog fullscreen (e.g. for full image view)
 */

(function (define) {
  'use strict';

  define(['config', 'utils'], function (config, utils) {

    var _ = utils._;

    var newMatchDialog = function($rootScope, $location, $ionicModal) {

      var modalScope = $rootScope.$new();
      modalScope.user = [];
      modalScope.imageControl = {};
      var filter = _.find(function(a){ return a.firstName != 'You'});
      modalScope.goto = function(type, id) {
        modalScope.action && modalScope.action();
        if (type == 'profile' && id) {
          $location.path('/app/profiles/' + id);
          modalScope.hide();
        } else if (type == 'chat' && id) {
          $location.path('/app/chat-room/' + id);
          modalScope.hide();
        } else {
          return false;
        }
      };

      var modalDeferred = $ionicModal.fromTemplateUrl('templates/dialogs/new-match.html', {
        scope: modalScope,
        animation: 'fade-in'
      });

      var show = function(options) {
        modalScope.user = filter(options.participants);
        modalScope.action = options && options.onClose;

        modalDeferred.then(function(modal){
          modalScope.imageControl.refresh(modalScope.user.imageId);
          //console.log('!!! --- imageControl:', modalScope.imageControl, modalScope);
          modalScope.hide = function() {
            modalScope.action && modalScope.action(true);
            modal.hide();
          };
          modal.show();
        });
      };

      return {
        show: show
      };
    };

    return newMatchDialog;
  })
}(define));