(function (define) {
  'use strict';

  define(['config'], function (config) {

    var kmGrobalErrorDir = function () {
      return {
        restrict: 'A',
        controller: function($scope, appEvents, geoLocation, $translate, $timeout){

          this.init = function(element){
            if (appEvents.get('isOffline')){
              element.removeClass('ng-hide');
              $translate('GLOBAL_ERROR_NO_INTERNET').then(function(translation) {
                  element.text(translation);
                }
              );
            }
            geoLocation.get().then().catch(function(){
              /*

              commented out to prevent first error from showing, but calling get to still create a location in memory

              element.removeClass('ng-hide');
              $translate('GLOBAL_ERROR_NO_GEO_LOCATION').then(function(translation) {
                  element.text(translation);
                }
              );*/
            });
            $scope.$on('app-offline', function(event){
              element.removeClass('ng-hide');
              $translate('GLOBAL_ERROR_NO_INTERNET').then(function(translation) {
                  element.text(translation);
                }
              );
            });
            $scope.$on('app-online', function(event){
              element.addClass('ng-hide');
              element.text('');
            });
            $scope.$on('app-location-error', function(event){
              element.removeClass('ng-hide');
              $translate('GLOBAL_ERROR_NO_GEO_LOCATION').then(function(translation) {
                  element.text(translation);
                }
              );
            });
            $scope.$on('app-location-good', function(event){
              element.addClass('ng-hide');
              element.text('');
            });
            $scope.$on('app-error', function(event, data){
              element.removeClass('ng-hide');
              console.log('- app-error: ', arguments);
              $translate(data.text).then(function(translation) {
                console.log('- app-error: ' + translation, arguments);
                element.text(translation || data.text);
              }).catch(function(){
                element.text(data.text);
              });
              data.timeout && removeError(element, data.timeout);
            });
          };
          function removeError(element, timeout){
            timeout = timeout || 0;
            $timeout(function(){
              element.addClass('ng-hide');
              element.text('');
            }, timeout);
          }
        },
        scope: {
          eventName: '='
        },
        link: function (scope, element, attrs, ctrl) {
          ctrl.init(element);
        }
      };
    };

    return kmGrobalErrorDir;
  });


}(define));