(function (define) {
  'use strict';

  define(['config'], function (config) {

    var kmOfflineDisableDir = function () {
      return {
        restrict: 'A',
        controller: function($scope, appEvents){

          this.init = function(element){
            if (appEvents.get('isOffline')){
              element.attr('disabled', 'disabled');
            }
            $scope.$on('app-offline', function(event){
              element.attr('disabled', 'disabled');
            });
            $scope.$on('app-online', function(event){
              element.removeAttr('disabled');
            });
          };
        },
        link: function (scope, element, attrs, ctrl) {
          ctrl.init(element);
        }
      };
    };

    return kmOfflineDisableDir;
  });


}(define));