(function (define) {
  'use strict';

  define(['config'], function (config) {

   var kmRefresher = function($ionicBind) {
      return {
        restrict: 'E',
        replace: true,
        //require: '^$ionicScroll',
        controller: function($scope, $timeout){
          var self = this;
          this._setRefresher = function(refresherScope, refresherElement) {
            console.log('kmRefresher ctrl._setRefresher');
            var refresher = this.refresher = refresherElement,
              isBlocked = false;

            activatePullToRefresh({
              activate: function() {
                refresher.classList.add('active');
                refresherScope.$onPulling();
              },
              deactivate: function() {
                refresher.classList.remove('active', 'refreshing', 'refreshing-tail');
              },
              start: function() {
                refresher.classList.add('refreshing');
                refresherScope.$onRefresh();
              },
              show: function(){
                refresher.classList.remove('invisible');
              },
              hide: function(){
                refresher.classList.add('invisible');
              },
              tail: function(){
                refresher.classList.add('refreshing-tail');
              }
            });
            function activatePullToRefresh(callbacks) {
              Object.keys(callbacks).forEach(function(key){
                //self[key] = function(){ ionic.requestAnimationFrame(callbacks[key]);}
                self[key] = function(){ if (!isBlocked) callbacks[key]();}
              });
              $scope.$on(config.event.SCROLL_PTR_ACTIVATE, self.activate);
              $scope.$on(config.event.SCROLL_PTR_DEACTIVATE, self.deactivate);
              $scope.$on(config.event.SCROLL_PTR_START, self.start);
              $scope.$on('scroll.refreshComplete', function() {
                self.hide();
                self.deactivate();
                isBlocked = true;
                $timeout(function(){
                  isBlocked = false;
                  self.show();
                }, 10*1000);
              });
            }
          };
        },
        template:
          '<div class="scroll-refresher" collection-repeat-ignore>' +
            '<div class="ionic-refresher-content" ' +
            'ng-class="{\'ionic-refresher-with-text\': pullingText || refreshingText}">' +
              '<div class="icon-pulling" ng-class="{\'pulling-rotation-disabled\':disablePullingRotation}">' +
                '<i class="icon {{pullingIcon}}"></i>' +
              '</div>' +
              '<div class="text-pulling" ng-bind-html="pullingText"></div>' +
              '<div class="icon-refreshing"><i class="icon {{refreshingIcon}}"></i></div>' +
              '<div class="text-refreshing" ng-bind-html="refreshingText"></div>' +
            '</div>' +
          '</div>',
        compile: function($element, $attrs) {
          if (angular.isUndefined($attrs.pullingIcon)) {
            $attrs.$set('pullingIcon', 'ion-ios7-arrow-down');
          }
          if (angular.isUndefined($attrs.refreshingIcon)) {
            $attrs.$set('refreshingIcon', 'ion-loading-d');
          }
          return function($scope, $element, $attrs, scrollCtrl) {
            $ionicBind($scope, $attrs, {
              pullingIcon: '@',
              pullingText: '@',
              refreshingIcon: '@',
              refreshingText: '@',
              disablePullingRotation: '@',
              $onRefresh: '&onRefresh',
              $onPulling: '&onPulling'
            });
            scrollCtrl._setRefresher($scope, $element[0]);

            //$scope.$on('scroll.refreshComplete', function() {
            //  $scope.$evalAsync(function() {
            //    scrollCtrl.scrollView.finishPullToRefresh();
            //  });
            //});
          };
        }
      };
    };

    return kmRefresher;
  });

}(define));