(function (define) {
  'use strict';

  define(['config'], function (config) {

    var kmStayFocused = function ($timeout) {
      return {
        restrict: 'A',
        scope: {
          'stayOpen': '=',
          'onReturn': '&',
          'onTyping': '&'
        },
        link: function(scope, element){
          var hasBlurred = false;
          element.bind('focus', function(e){
            if(!scope.stayOpen && !hasBlurred) {
              scope.stayOpen = true;
              //console.log("* KEYBOARD * : 20 stayOpen set true ");
            }else if(!scope.stayOpen && hasBlurred){
              hasBlurred = false;
              //console.log("* KEYBOARD * : 23 hasBlurred set false ");
            }
          });
          element.bind('blur', function(e){
            if(scope.stayOpen && !hasBlurred) {
              hasBlurred = true;
              //console.log("* KEYBOARD * : 35 hasBlurred set true ");
              scope.stayOpen = false;
              //console.log("* KEYBOARD * : 34 stayOpen set false ");
              element[0].focus();
              $timeout(function(){
                if (!scope.stayOpen){
                  //console.log("* KEYBOARD * : 41 failed to stay open " + scope.stayOpen);
                  element[0].blur();
                }
              }, 100);
            }
          });
          element.bind('keydown', function(e){
            if(e.which == 13){
              if(scope.onReturn){
                e.preventDefault();
                $timeout(function(){
                  scope.onReturn();
                });
              }
            } else {
              if(scope.onTyping) scope.onTyping();
            }
          });
        }
      };
    };

    return kmStayFocused;
  });


}(define));