(function (define) {
  'use strict';

  define(['config'], function (config) {

    var kmUndoDir = function ($rootScope, $ionicGesture, $timeout) {
      return {
        restrict: 'E',
        controller: function($scope){

        },
        link: function (scope, element, attrs, ctrl) {
          var undoing = false;
          var letDrag = true;
          var screenWidth = scope.contentWidth;
          element.css('right',  '-' + screenWidth + 'px');
          element.css('width',  screenWidth+50 + 'px');
          var dragFn = function (e) {
            if (letDrag) {
              element.removeClass('animate');
              var dist = e.gesture.distance;
              if (dist < screenWidth) {
                element.css('right', dist - screenWidth + 'px');
              }
              if (dist > screenWidth-50) {
                undoing = true;
                letDrag = false;
                console.log("Trigger Undo");
                $rootScope.$broadcast('undo-match');
                // trigger undo and close
                // maybe have some animation that its doing something before it closes (below code)
                $timeout(function () {
                  undoing = false;
                  dragStop();
                }, config.ttl.MATCH_UNDO_SEC * 1000);
              }
            }
          };
          var dragStop = function (e) {
            if (!undoing) {
              element.addClass('animate');
              element.css('right', '-'+screenWidth+'px');
              undoing = true;
            } else if (undoing && !letDrag) {
              letDrag = true;
            } else {
              element.addClass('animate');
              element.css('right', '-'+screenWidth+'px');
            }
          };
          scope.$on('$destroy', function () {
            $ionicGesture.off(dragGesture, 'drag', dragFn);
          });
          var dragGesture = $ionicGesture.on('drag', dragFn, element);
          $ionicGesture.on('release', dragStop, element);

        }
      };
    };

    return kmUndoDir;
  });


}(define));