(function (define) {
  'use strict';

  define(['config'], function (config) {

    var kmAudioDir = function () {
      return {
        restrict: 'E',
        templateUrl: 'templates/components/km-audio-panel.html',
        controller: 'Kismet.media.AudioCtrl',
        scope: {
          onSend: '=',
          onCancel: '='
        },
        link: function (scope, element, attrs, ctrl) {
          var _fileEntry;

          scope.isPlayDisabled = true;
          scope.isPauseDisabled = true;
          scope.isStopDisabled = true;
          scope.isRecording = false;

          scope.recordStart = function(){
            if (scope.isPlaying) return;

            scope.isRecording = true;
            scope.isStopDisabled = false;
            scope.isPlayDisabled = true;

            ctrl.recordStart()
              .then(function(fileEntry){
                scope.recordStop();
                scope.isPlayDisabled = false;
                _fileEntry = fileEntry;
              })
              .catch(function(err){
                alert('error/cancelled: ' + err);
                scope.recordStop();
              });
          };
          scope.recordStop = function(){
            ctrl.recordStop()
            scope.isStopDisabled = true;
            scope.isRecording = false;
          };

          scope.playStart = function(){
            if (scope.isPlayDisabled) return;

            scope.isPlaying = true;
            ctrl.play()
              .then(function(){
                scope.isPlaying = false;
              })
              .catch(function(){
                scope.isPlaying = false;
              });
          };
          scope.playStop = function(){
            scope.isPlaying = false;
            ctrl.stop();
          };

          scope.send = function(){
            if (scope.isPlayDisabled) return;

            scope.isRecording = false;
            scope.onSend({
              upload: ctrl.upload,
              fileEntry: _fileEntry
            });
            scope.isPlayDisabled = true;
          };
          scope.cancel = function(){
            scope.isRecording = false;
            scope.isPlayDisabled = true;
            scope.onCancel();
          };
        }
      };
    };

    return kmAudioDir;
  });


}(define));