(function (define) {
  'use strict';

  define(['config'], function (config) {

    var appState = function () {

      var state = {
        isOffline: function(){
          if (navigator.network) {
            return navigator.network.connection.type === Connection.NONE;
          } else {
            return false;
          }
        },
        isBackground: false,
        isDeviceRegistered: false
      };

      document.addEventListener('resume', function(){
        state.isBackground = false;
      });
      document.addEventListener('pause', function(){
        state.isBackground = true;
      });

      function get(name){
        var param = state[name];
        return param && (typeof param === 'function' ? state[name]() : param);
      }
      function set(name, value){
        console.log('[appState.set] ' + name + ' = ' + value);
        if (typeof state[name] !== 'undefined' && typeof state[name] !== 'function') state[name] = value;
      }

      return {
        get: get,
        set: set
      };
    };

    return appState;
  })
}(define));