(function (define) {
  'use strict';

  define(['config'], function (config) {

    var localNotification = function(appState) {

      var counters = {},
        defaultOptions = {
          title: 'Kismet',
          id: 'kismet-message'
          //sound: String
        }, enabled = window.plugin && window.plugin.notification && window.plugin.notification.local;

      function add(options, callback){
        if (enabled && appState.get('isBackground')){
          options = angular.extend(defaultOptions, options);

          if (typeof counters[options.id] === 'undefined') {
            counters[options.id] = 0;
          }
          options.badge = ++counters[options.id];

          window.plugin.notification.local.add(options, function(){
            window.plugin.notification.local.onclick = function (id, state, json) {
              callback && callback(JSON.parse(json));
              counters[id] = 0;
            };
          });
        }
      }

      return {
        add: add
      };
    };

    return localNotification;
  })
}(define));