(function (_) {

  var utils = {

    '_' : _,

    maybeArr: function(a){ return a || []},

    maybe: _.curry(function(defVal, a){
      return a || defVal;
    }),

    cleanUpMessage: function(text) {
      if (!text) {
        return text;
      }
      text = this.htmlEntities(text);
      // enters to BRs
      text = text.replace(/(?:\r\n|\r|\n)/g, '<br />');
      // emails TODO: not working with domain (double replaces) must make a smart if -- started below
      // text = text.replace(/((?:[\w\!\#\$\%\&\'\*\+\-\/\=\?\^\`\{\|\}\~]+\.)*[\w\!\#\$\%\&\'\*\+\-\/\=\?\^\`\{\|\}\~]+@(?:(?:(?:[a-zA-Z0-9](?:[a-zA-Z0-9\-](?!\.)){0,61}[a-zA-Z0-9]?\.)+[a-zA-Z0-9](?:[a-zA-Z0-9\-](?!$)){0,61}[a-zA-Z0-9]?)|(?:\[(?:(?:[01]?\d{1,2}|2[0-4]\d|25[0-5])\.){3}(?:[01]?\d{1,2}|2[0-4]\d|25[0-5])\])))/ig,'<a href="mailto:$1">$1</a>');
      // links
      text = text.replace(/^([a-z][a-z0-9\*\-\.]*):\/\/(?:(?:(?:[\w\.\-\+!$&'\(\)*\+,;=]|%[0-9a-f]{2})+:)*(?:[\w\.\-\+%!$&'\(\)*\+,;=]|%[0-9a-f]{2})+@)?(?:(?:[a-z0-9\-\.]|%[0-9a-f]{2})+|(?:\[(?:[0-9a-f]{0,4}:)*(?:[0-9a-f]{0,4})\]))(?::[0-9]+)?(?:[\/|\?](?:[\w#!:\.\?\+=&@!$'~*,;\/\(\)\[\]\-]|%[0-9a-f]{2})*)?$/ig,
            function(match, capture) {
              //console.log('URL FOUND: ' + match + ' | ' + match);
              var txt = utils.htmlEntities(match, true);
              // http://maps.google.com/maps?q={lat},{long}
              if (/^http:\/\/(maps.google.com\/maps\?q=[\d\-\.]+,[\d\-\.]+)$/.test(match)) {
                txt = 'Go to map...';
              }
              return '<a class="purple-link" href="' + match + '" onclick="window.open(this.href,\'_system\'); return false;">' + txt + '</a>';
            }
      );
      return text;
    },

    htmlEntities: function(text, force) {
      text = text.trim();
      // html entities
      if (force) text = text.replace(/&/g, '&amp;');

      return text
        .replace(/</g, '&lt;')
        .replace(/>/g, '&gt;')
        .replace(/"/g, '&quot;')
        .replace(/'/g, '&#39;');
    }

  };

  if (typeof exports === 'object') {
    module.exports = utils;
  } else if (typeof define === 'function' && define.amd) {
    define(utils);
  }
}(ramda));